package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    return employeeRepository.findAll();
  }

  public Employee addEmployee(Employee employee) {
    return employeeRepository.saveAndFlush(employee);
  }

  public void getEmployeeByIdAndDelete(long employeeId) {
     employeeRepository.deleteById(employeeId);
  }

  public String updateEmployee(long employeeId, Employee employee) {
    Optional<Employee> employeeOptional = employeeRepository.findById(employeeId);
    if (!employeeOptional.isPresent()) return "employee id doesn't exist";
    employee.setId(employeeId);
    employeeRepository.save(employee);
    return "employee updated";
  }

  public Optional<Employee> getEmployeeById(Long employeeId) {
    return employeeRepository.findById(employeeId);
  }
}
